#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <XSP2lib.H>
#include "main.h"
#include "enemy.h"
#include "fxsp2lib.h"
#include "parts.h"

#define ENEMY_MAX	256	/* ő吔 */


#define P1_K	0.5		/* ΂˒萔iEp[cj */
#define P1_M	0.2		/* CviEp[cj */
#define P1_V	0.5		/* xȉȂ玟ցiEp[cj */
#define P1_L	0.4		/* WȉȂ玟ցiEp[cj */

/* QiKڑp[c̎ */
#define P3_K	1.5		/* ΂˒萔 */
#define P3_M	0.10		/* Cv */
#define P3_V	0.8		/* xȉȂ玟 */
#define P3_L	0.8		/* WȉȂ玟 */

/* QiKڍEp[c */
#define P5_K	3.0		/* ΂˒萔iE㏬p[cj */
#define P5_M	0.02		/* CviE㏬p[cj */
#define P5_V	0.1		/* xȉȂ玟ցiE㏬p[cj */
#define P5_L	0.1		/* WȉȂ玟ցiE㏬p[cj */

/* QiKڍEp[c */
#define P7_K	3.0		/* ΂˒萔iE㏬p[cj */
#define P7_M	0.02		/* CviE㏬p[cj */
#define P7_V	0.1		/* xȉȂ玟ցiE㏬p[cj */
#define P7_L	0.1		/* WȉȂ玟ցiE㏬p[cj */


static ENEMY *enemy_top,	/* gp̃[ÑXg */
 *enemy_null_top,		/* ̃[ÑXg */
 *enemy_end;			/* gp[ÑXg̖ */

static ENEMY enemy[ENEMY_MAX];	/* [N */

extern char end_of_data;
extern char f_option_flag;

typedef struct _spwork {
	signed short x, y;	/* W */
	unsigned short pt;	/* XvCgp^[mD */
	unsigned short info;	/* ]R[hEFEDx\킷f[^ */
} SPWORK;


SPWORK spwork;

FILE *fp_parts3, *fp_parts5, *fp_parts6, *fp_parts7, *fp_parts8;


int EnemyInit0 (void)
{
	int i;

	/* XgȂ */
	enemy_top = NULL;
	enemy_end = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;

	return (0);
}



void EnemyInit (unsigned short type, unsigned short info,
		signed short ox, signed short oy, ENEMY * parent)
{
	ENEMY *p;

	if (enemy_null_top == NULL) {
		printf ("[Ntł\n");
		return;		/* 󂫂̃[NȂiLN^[I[o[j */
	}
	/* Xg̖ɐVm[hǉ */
	p = enemy_null_top;
	enemy_null_top = p->next;
	if (enemy_top == NULL)
		enemy_top = p;
	else
		enemy_end->next = p;
	p->next = NULL;
	enemy_end = p;

	p->type = type;
	p->info = info;
	p->ox = ox;
	p->oy = oy;
	p->x = 0;
	p->y = 0;
	p->parent = parent;

	p->lx = 0.0;
	p->ly = 0.0;
	p->lz = 0.0;
	p->vx = 0.0;
	p->vy = 0.0;
	p->vz = 0.0;
	p->cyc = 0;
	p->cyc1 = 0;

	switch (p->type) {
	case 0:		/* RA */
		//if (f_option_flag)
			//fp_parts3 = fopen ("parts3.doc", "w");
		p->lz = 9.0;
		p->ox = 0;
		break;
	default:
		break;
	}
}


/* ̃XvCgō\Ăp[cP̃XvCg܂Ƃ߂ĕ\ */
static void DispSp (ENEMY * p, short sp_num, PARTS_TABLE * parts_table)
{
	short h;

	for (h = 0; h < sp_num; h++) {
		p->x = p->lx + p->ox;
		p->y = p->ly + p->oy;
		if (p->parent != NULL) {
			spwork.x = p->x + p->parent->x + parts_table[h].x;
			spwork.y = p->y + p->parent->y + parts_table[h].y;
		} else {
			spwork.x = p->x + parts_table[h].x;
			spwork.y = p->y + parts_table[h].y;
		}
		spwork.pt = parts_table[h].pt;
		spwork.info = p->info;

		spwork.x += (128 + 16);	/* \pɕ␳ */
		spwork.y += (128 + 16);
		xsp_set_st (&spwork);
		fxsp_set_st (&spwork);
		spwork.x -= (128 + 16);
		spwork.y -= (128 + 16);
	}
}



void EnemyMove (void)
{
	ENEMY *p, *q;

	p = enemy_top;
	q = NULL;
	while (p != NULL) {
		char erase_flag = 0;

		switch (p->type) {
		case 0:	/* RA */
			p->lx = p->lz * cos (p->round) - 8.0;
			p->ly = p->lz * sin (p->round) - 8.0;
			DispSp (p, 1, parts0_table);
			p->lx = p->lz * cos (p->round+M_PI*0.5) - 8.0;
			p->ly = p->lz * sin (p->round+M_PI*0.5) - 8.0;
			DispSp (p, 1, parts0_table);
			p->lx = p->lz * cos (p->round+M_PI*1.0) - 8.0;
			p->ly = p->lz * sin (p->round+M_PI*1.0) - 8.0;
			DispSp (p, 1, parts0_table);
			p->lx = p->lz * cos (p->round+M_PI*1.5) - 8.0;
			p->ly = p->lz * sin (p->round+M_PI*1.5) - 8.0;
			DispSp (p, 1, parts0_table);

			p->round += M_PI / 2.0 /16.0;
			if (seq_counter == 15)
				erase_flag = !0;
			break;

		case 1:	/* PiKڂŕ{ */
			DispSp (p, 24, parts1_table);
			if (seq_counter == 58)
				erase_flag = !0;
			break;
		case 2:	/* PiKڂŕ */
			DispSp (p, 30, parts2_table);
			erase_flag = !0;
			break;

		case 3:	/* QiKڑp[c */
			switch (p->cyc) {
			case 0:
				p->ly += p->vy;
				if (p->ly < 32.0)
					p->cyc++;
				break;
			case 1:
				if ((p->ly > 1.0) && (p->vy < -1.2))
					p->vy += 0.8;
				p->ly += p->vy;
				if (p->ly < 1.0)
					p->cyc++;
				break;
			case 2:/* ΂ːU */
				p->vy -= p->ly * P3_K;
				/* C */
				if (p->vy > 0)
					p->vy -= P3_M;
				else
					p->vy += P3_M;
				p->ly += p->vy;
				if ((fabs (p->vy) < P3_V) && (fabs (p->ly) < P3_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			case 3:
				erase_flag = !0;
				break;
			default:
				break;
			}
			if (f_option_flag)
				fprintf (fp_parts3, "{%d,%d}, ", (int) (p->lx + p->ox), (int) (p->ly + p->oy));
			DispSp (p, 60, parts3_table);
			break;

		case 4:	/* QiKږ{ */
			DispSp (p, 90, parts4_table);
			break;

		case 5:	/* p[c */
			switch (p->cyc) {
			case 0:
				p->cyc++;	/*  */
				p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
				p->vz = 0.0;
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = (18 - 54) * p->lz;	/* I_-n_ */
				p->ly = (168 - 143) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox += (18 - 54);
					p->oy += (168 - 143);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P5_K;
				/* C */
				if (p->vz > 0)
					p->vz -= P5_M;
				else
					p->vz += P5_M;
				p->lz += p->vz;
				p->lx = (18 - 54) * p->lz;
				p->ly = (168 - 143) * p->lz;
				if ((fabs (p->vz) < P5_V) && (fabs (p->lz) < P5_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			if (f_option_flag)
				fprintf (fp_parts5, "{%d,%d}, ", (int) (p->lx + p->ox), (int) (p->ly + p->oy));
			DispSp (p, 16, parts5_table);
			break;

		case 6:	/* Ep[c */
			switch (p->cyc) {
			case 0:
				p->cyc++;	/*  */
				p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
				p->vz = 0.0;
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = -(18 - 54) * p->lz;	/* I_-n_ */
				p->ly = (168 - 143) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox -= (18 - 54);
					p->oy += (168 - 143);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P5_K;
				/* C */
				if (p->vz > 0)
					p->vz -= P5_M;
				else
					p->vz += P5_M;
				p->lz += p->vz;
				p->lx = -(18 - 54) * p->lz;
				p->ly = (168 - 143) * p->lz;
				if ((fabs (p->vz) < P5_V) && (fabs (p->lz) < P5_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			if (f_option_flag)
				fprintf (fp_parts6, "{%d,%d}, ", (int) (p->lx + p->ox), (int) (p->ly + p->oy));
			DispSp (p, 16, parts6_table);
			break;

		case 7:	/* p[c */
			switch (p->cyc) {
			case 0:
				p->cyc++;	/*  */
				p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
				p->vz = 0.0;
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = (65 - 68) * p->lz;	/* I_-n_ */
				p->ly = (115 - 134) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox += (65 - 68);
					p->oy += (115 - 134);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P7_K;
				/* C */
				if (p->vz > 0)
					p->vz -= P7_M;
				else
					p->vz += P7_M;
				p->lz += p->vz;
				p->lx = (65 - 68) * p->lz;
				p->ly = (115 - 134) * p->lz;
				if ((fabs (p->vz) < P7_V) && (fabs (p->lz) < P7_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
					end_of_data = !0;	/* debug */
				}
				break;
			default:
				break;
			}
			if (f_option_flag)
				fprintf (fp_parts7, "{%d,%d}, ", (int) (p->lx + p->ox), (int) (p->ly + p->oy));
			DispSp (p, 9, parts7_table);
			break;

		case 8:	/* Ep[c */
			switch (p->cyc) {
			case 0:
				p->cyc++;	/*  */
				p->lz = 0.0;	/* n_ 0.0, I_ 1.0 */
				p->vz = 0.0;
				break;
			case 1:/* xIɗ */
				if (p->vz < 0.20)
					p->vz += 0.10;
				p->lz += p->vz;
				p->lx = -(65 - 68) * p->lz;	/* I_-n_ */
				p->ly = (115 - 134) * p->lz;
				if (p->lz > 1.0) {
					p->cyc++;	/*  */
					p->lz = 0.0;
					p->lx = 0.0;	/* x͂_ɂȂ */
					p->ly = 0.0;
					p->ox -= (65 - 68);
					p->oy += (115 - 134);
				}
				break;
			case 2:/* ΂ːU */
				p->vz -= p->lz * P7_K;
				/* C */
				if (p->vz > 0)
					p->vz -= P7_M;
				else
					p->vz += P7_M;
				p->lz += p->vz;
				p->lx = -(65 - 68) * p->lz;
				p->ly = (115 - 134) * p->lz;
				if ((fabs (p->vz) < P7_V) && (fabs (p->lz) < P7_L)) {
					p->cyc++;	/*  */
					p->lx = 0.0;
					p->ly = 0.0;
					p->vx = 0.0;
					p->vy = 0.0;
				}
				break;
			default:
				break;
			}
			if (f_option_flag)
				fprintf (fp_parts8, "{%d,%d}, ", (int) (p->lx + p->ox), (int) (p->ly + p->oy));
			DispSp (p, 9, parts8_table);
			break;

		default:
			printf ("enemy_move() : oOĂ܂\n");
			break;
		}

		if (erase_flag) {
			if (q == NULL) {	/* Xg̈ԍŏ폜 */
				enemy_top = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				q = NULL;
				p = enemy_top;
			} else {
				q->next = p->next;
				p->next = enemy_null_top;
				enemy_null_top = p;
				p = q->next;
			}
		} else {
			q = p;
			p = p->next;
		}
	}
}


void EnemyTini (void)
{
	int i;

	/* XgȂ */
	enemy_top = NULL;
	enemy_null_top = enemy;
	for (i = 0; i < ENEMY_MAX; i++)
		enemy[i].next = &enemy[i + 1];

	enemy[ENEMY_MAX - 1].next = NULL;
}
